#ifndef _SEGMENT_H_
#define _SEGMENT_H_

#include "functions.h"
#include <iostream>

typedef int length_t;

using namespace std;


class segment {
   length_t m_dFrom;
   length_t m_dTo;
public:
   segment() {
      m_dFrom = m_dTo = 0;
   }
   segment(length_t dFrom, length_t dTo) {
      assign(dFrom, dTo);
   }
   void assign(length_t dFrom, length_t dTo);
   segment& erase();
   length_t getLength() const;
   length_t getFrom() const;
   length_t getTo() const;
   void setFrom(length_t dFrom);
   void setTo(length_t dTo);
   bool overlaps(const segment& seg) const;
   bool contains(const segment& seg) const;
   bool inside(const segment& seg) const;
   segment& add(const segment& seg);
   segment& sub(const segment& seg);
   length_t dist(const segment& seg) const;
   void print(FILE* fout) const;
   void print(ostream& os) const;
   /** No descriptions */
   virtual segment& operator =(const segment& seg);
};
//=====================================================
ostream& operator <<(ostream& os, const segment& seg);

#endif // _SEGMENT_H_
